#include<bits/stdc++.h>
using namespace std;
int n, q, a[100001], par[100001];
void add(int v){
    if(par[v] == 0)return;
    a[par[v]] += a[v] + 1;
    //cout << v << " " << par[v] << " " << a[par[v]] << endl;
    add(par[v]);
}
int main(){

    ios_base::sync_with_stdio(0); cin.tie(0); cout.tie(0);
    cin >> n;
    for(int i = 1; i < n; i++){
        int u, v; cin >> u >> v;
        par[v] = u;
        add(v);
    }
    cin >> q;
    for(int i = 0; i < q; i++){
        int in; cin >> in;
        cout << a[in] << endl;
    }

    return 0;
}
